Bug 989 - Wishlist: include a bit more tools in shipped busybox
: Wishlist: include a bit more tools in shipped busybox
Status: RESOLVED WONTFIX
Product: Core
Busybox
: unspecified
: All Maemo
: Medium enhancement with 2 votes (vote)
: ---
Assigned To: Eero Tamminen
: busybox-bugs
:
: enhancement-it2007
:
:
  Show dependency tree
 
Reported: 2007-01-28 14:37 UTC by Laurent GUERBY
Modified: 2009-04-10 14:53 UTC (History)
4 users (show)

See Also:


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description Laurent GUERBY (reporter) 2007-01-28 14:37:31 UTC
Here is a diff between a repackaging done by volunteers and what is currently
included in busybox:

+ depmod
+ ip
+ nc
+ ping
+ ping6
+ telnet
+ traceroute
+ wget

Discussion here:

http://maemo.org/pipermail/maemo-users/2007-January/003108.html

PS: enhancement-it2007 is not available as a bugzilla keyword.
Comment 1 Laurent GUERBY (reporter) 2007-02-07 21:53:40 UTC
While I'm at it, given the flakyness of some MMC/SD cards I believe compiling
md5sum in busybox would be useful too.
Comment 2 Laurent GUERBY (reporter) 2007-02-18 18:58:17 UTC
Another user:

http://maemo.org/pipermail/maemo-users/2007-February/004021.html

Mentions "nmap" too, a port here:
http://www.mulliner.org/nokia770/
Comment 3 Jake Kunnari 2007-03-14 14:28:03 UTC
Assigned to Quim Gil
Comment 4 Jake Kunnari 2007-03-14 14:28:35 UTC
-
Comment 5 Quim Gil nokia 2007-03-14 14:40:01 UTC
I will investigate b
why our Busybox has these tools and not others + future plans.
Comment 6 Quim Gil nokia 2007-03-14 15:00:13 UTC
In the meantime...

> PS: enhancement-it2007 is not available as a bugzilla keyword.

Fixed: https://maemo.org/bugzilla/show_bug.cgi?id=1140
Comment 7 Quim Gil nokia 2007-03-16 09:37:57 UTC
In order to find the right answer it would be helpful to know:

- A rank of tools power users would like to see added, with a rationale.
Which are the most relevant, which are just mildly needed.

- If there are ongoing community plans to provide a replacement or
complementary BusyBox with these tools, or the tools themselves package
by package.

- As you see there are several options, which one would be your
preferred and why.
Comment 8 Laurent GUERBY (reporter) 2007-03-16 09:50:56 UTC
(In reply to comment #7)
> In order to find the right answer it would be helpful to know:
> 
> - A rank of tools power users would like to see added, with a rationale.
> Which are the most relevant, which are just mildly needed.

> - If there are ongoing community plans to provide a replacement or
> complementary BusyBox with these tools, or the tools themselves package
> by package.

As said in the first comment, the community *already* packages those tools (most
of them inside a new busybox, some externally in separate package), the problem
is that busybox is critical to correct functionning of N770/N800 so community
replacing busybox is hard and leads to lots of "not booting", messages on the
list, issue with new official releases, etc... => nightmare.

So my take is that you have to weight the above "bad experiences" with just
adding 9 tools to the Nokia busybox build that already includes about 100 tools
so it's not a big increase. 

The tools I cite are mostly network stuff for scripting and checking various
weird network issue. md5sum is not network but is useful IMHO to check flaky
card harware.


+ depmod
+ ip
+ nc
+ ping
+ ping6
+ telnet
+ traceroute
+ wget
+ md5sum
Comment 9 Priit Laes 2007-03-16 15:58:58 UTC
This is for checking logfiles:
- less
Comment 10 Laurent GUERBY (reporter) 2007-03-23 23:44:19 UTC
I would add:
- file  (to go with less before trashing your terminal :)
Comment 11 Randall Arnold 2007-04-06 00:01:56 UTC
ping and telnet for sure.  I would think that goes without saying!
Comment 12 Eero Tamminen nokia 2007-04-27 11:59:03 UTC
Tools can be provided as separate packages that are available from the Maemo
repositories (e.g. in the next SDK release).  Tools that are not part of
Busybox do not belong to this bug though.


If you want tools into Busybox which goes to the product, there needs
to be good rationale for each tool why they are included (as Gil explained
in comment 7).  Rationale needs to have all of these:
- The tool is generally useful for most developers
  -> True for all the currently listed packages
- Tool increases Busybox size only few KB
  -> What is the size of the 3rd party Busybox including all the tools
     listed in first comment?
- That tool is provided by a Debian Essential package, but not by Busybox
  -> In which Debian essential package?

If the tool is not in Debian essentials, I don't think it belongs to
Busybox as then trying to install the real tool would uninstall Busybox
(and half of the device software).
Comment 13 Quim Gil nokia 2007-05-05 11:06:24 UTC
Reassigning bug to Eero since he is working on developers tools. 

Laurent, the bottomline is that we are improving the collection of developer
tools officially supported. Soon you will see the first improvements in the
maemo repository, the simplest channel to provide them. 

Touching the busybox package is a more delicate option, I'll leave to Eero and
the busibox package maintainers the decision on this. The default principle
should be alignment with upstream though, as we are trying to do with the rest
of packages whenever possible.
Comment 14 Laurent GUERBY (reporter) 2007-05-05 12:41:18 UTC
Quim, Eero, thanks that's great news!
Comment 15 Eero Tamminen nokia 2007-05-23 14:54:21 UTC
Marking as WONTFIX, busybox won't be modified as that would create more
problems (one cannot install the real versions of the tools).

Along with the next Maemo SDK there will be some tools as separately
installable packages in the Maemo repositories.
Comment 16 Eero Tamminen nokia 2008-01-02 16:12:15 UTC
The listed networking utilities are already available from the tools repository
as separate packages, see:
    http://maemo.org/development/tools/

As to the other listed tools, Busybox already provides:
- "module-init-tools" package which on Debian contains "depmod"
- "coreutils" package which on Debian contains "md5sum"
so, I think it could be valid to have those in Busybox binary.

Please create a separate bug about those ("Busybox should contain binaries
from the packages it claims to provide") and put me on CC.
Comment 17 Eero Tamminen nokia 2008-04-28 11:20:52 UTC
(In reply to comment #16)
> The listed networking utilities are already available from the tools
> repository as separate packages, see:
>         http://maemo.org/development/tools/
> 
> As to the other listed tools, Busybox already provides:
> - "module-init-tools" package which on Debian contains "depmod"
> - "coreutils" package which on Debian contains "md5sum"
> so, I think it could be valid to have those in Busybox binary.
> 
> Please create a separate bug about those ("Busybox should contain binaries
> from the packages it claims to provide") and put me on CC.

You could mention those bug numbers here too.
Comment 18 Andre Klapper maemo.org 2009-04-08 15:45:21 UTC
FYI, some stuff here might also be covered by bug 4248 which is being
considered for Fremantle.
Comment 19 Lucas Maneos 2009-04-10 14:53:37 UTC
(In reply to comment #18)
> FYI, some stuff here might also be covered by bug 4248 which is being
> considered for Fremantle.

Not directly related, as that deals with features on already enabled busybox
functions.

However, from the list in comment #8 wrt to Fremantle:

> + ping
> + ping6
> + md5sum

These are enabled in Fremantle, and also an iputils-ping package is provided
(?!)

> + nc
> + traceroute
> + wget

"Real" netcat, traceroute & wget are already available in the Diablo tools
repository, presumably they will also be available in the Fremantle equivalent.

> + depmod

Fremantle uses module-init-tools instead.

> + ip

Already provided in Diablo (iproute package).  Not present in Fremantle alpha,
but I assume it'll be there eventually.

> + telnet

This is potentially useful for debugging, troubleshooting etc and is tiny.  On
the other hand, a "real" telnet package (bonus points: make it telnet-ssl)
could be ported to extras.